"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ISOIEC7864Padding = void 0;
class ISOIEC7864Padding {
    addPadding(data, blockSize) {
        const paddingLength = blockSize - data.length % blockSize;
        return new Uint8Array([...data, 0x80, ...new Array(paddingLength - 1).fill(0)]);
    }
    removePadding(data) {
        let index = data.length - 1;
        while (data[index] !== 0x80)
            index -= 1;
        return data.slice(0, index);
    }
}
exports.ISOIEC7864Padding = ISOIEC7864Padding;
