"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OptionalParameterBuilder = void 0;
class OptionalParameterBuilder {
    builder;
    constructor(builder) {
        this.builder = builder;
    }
    get expectedTypes() {
        const expectedTypes = new Set(this.builder.expectedTypes);
        expectedTypes.add('undefined');
        return expectedTypes;
    }
    build(value, logger) {
        logger.log('OptionalParameterBuilder.build', { expectedTypes: this.builder.expectedTypes, value: value });
        if (typeof value === 'undefined')
            return undefined;
        return this.builder.build(value, logger.nextIndent);
    }
}
exports.OptionalParameterBuilder = OptionalParameterBuilder;
