"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Flattable = void 0;
var Flattable;
(function (Flattable) {
    function flatten(value) {
        if (typeof value === 'object' && value !== null && 'flatten' in value)
            return flatten(value.flatten);
        if (typeof value === 'undefined' || value === null || typeof value === 'boolean' || typeof value === 'number' || typeof value === 'bigint' || typeof value === 'string')
            return value;
        if (Array.isArray(value))
            return value.map(element => flatten(element));
        if (typeof value === 'object') {
            return Object.fromEntries(Object.entries(value).map(([key, value]) => [key, flatten(value)]));
        }
        throw new Error('Unexpected value');
    }
    Flattable.flatten = flatten;
})(Flattable = exports.Flattable || (exports.Flattable = {}));
