"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const crypto_1 = require("crypto");
const src_1 = require("../../src");
const chai_1 = require("chai");
describe('ICrypter', () => {
    it('encrypt and decrypt', () => {
        const aes = new src_1.AES((0, crypto_1.randomBytes)(16));
        for (let i = 1; i < 16; i++) {
            for (let j = 0; j <= i; j++) {
                const data = (0, crypto_1.randomBytes)(j);
                const encryptedData = aes.encrypt(data);
                const decryptedData = aes.decrypt(encryptedData);
                (0, chai_1.expect)(decryptedData).to.be.deep.equal(data);
            }
        }
    });
});
